## labplot 2.11.1

=== data/CMakeLists.txt ===
add_subdirectory(colormaps)
add_subdirectory(color-schemes)
add_subdirectory(pics)
add_subdirectory(pics/gsl_distributions)
add_subdirectory(pics/fit_models)
add_subdirectory(pics/colorchooser)
add_subdirectory(themes)
add_subdirectory(datasets)
add_subdirectory(examples)

=== icons/CMakeLists.txt ===
ecm_install_icons(
ICONS
128-apps-labplot2.png
150-apps-labplot2.png
16-apps-labplot2.png
22-apps-labplot2.png
256-apps-labplot2.png
310-apps-labplot2.png
32-apps-labplot2.png
44-apps-labplot2.png
48-apps-labplot2.png
512-apps-labplot2.png
64-apps-labplot2.png
sc-apps-labplot2.svgz
DESTINATION ${KDE_INSTALL_ICONDIR}/)

=== lib/CMakeLists.txt ===
cmake_policy(SET CMP0079 NEW)

set(KDEFRONTEND_DIR ../src/kdefrontend)
set(BACKEND_DIR ../src/backend)
set(COMMONFRONTEND_DIR ../src/commonfrontend)
set(TOOLS_DIR ../src/tools)
set(CMAKE_AUTOMOC ON)
set(SRC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)
add_definitions (-DSDK)

include(GenerateExportHeader)

# do not process these files
set_property(SOURCE gsl_parser.hpp gsl_parser.cpp PROPERTY SKIP_AUTOMOC ON)

set(GUI_SOURCES
	${KDEFRONTEND_DIR}/GuiTools.cpp
	${KDEFRONTEND_DIR}/ThemeHandler.cpp)

set(BACKEND_SOURCES
	${BACKEND_DIR}/core/Time.cpp
	${BACKEND_DIR}/core/Folder.cpp
	${BACKEND_DIR}/core/AbstractAspect.cpp
	${BACKEND_DIR}/core/AbstractColumn.cpp
	${BACKEND_DIR}/core/AbstractColumnPrivate.cpp
	${BACKEND_DIR}/core/abstractcolumncommands.cpp
	${BACKEND_DIR}/core/AbstractFilter.cpp
	${BACKEND_DIR}/core/AbstractSimpleFilter.cpp
	${BACKEND_DIR}/core/column/Column.cpp
	${BACKEND_DIR}/core/column/ColumnPrivate.cpp
	${BACKEND_DIR}/core/column/ColumnStringIO.cpp
	${BACKEND_DIR}/core/column/columncommands.cpp
	${BACKEND_DIR}/core/Project.cpp
	${BACKEND_DIR}/core/AbstractPart.cpp
	${BACKEND_DIR}/core/Workbook.cpp
	${BACKEND_DIR}/core/AspectTreeModel.cpp
	${BACKEND_DIR}/core/Settings.cpp
	${BACKEND_DIR}/core/datatypes/SimpleCopyThroughFilter.h
	${BACKEND_DIR}/core/datatypes/Double2DateTimeFilter.h
	${BACKEND_DIR}/core/datatypes/Double2DayOfWeekFilter.h
	${BACKEND_DIR}/core/datatypes/Double2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/Double2BigIntFilter.h
	${BACKEND_DIR}/core/datatypes/Double2MonthFilter.h
	${BACKEND_DIR}/core/datatypes/Double2StringFilter.cpp
	${BACKEND_DIR}/core/datatypes/Integer2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/Integer2BigIntFilter.h
	${BACKEND_DIR}/core/datatypes/Integer2DateTimeFilter.h
	${BACKEND_DIR}/core/datatypes/Integer2DayOfWeekFilter.h
	${BACKEND_DIR}/core/datatypes/Integer2MonthFilter.h
	${BACKEND_DIR}/core/datatypes/Integer2StringFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2StringFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2DateTimeFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2MonthFilter.h
	${BACKEND_DIR}/core/datatypes/BigInt2DayOfWeekFilter.h
	${BACKEND_DIR}/core/datatypes/String2DayOfWeekFilter.h
	${BACKEND_DIR}/core/datatypes/String2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/String2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/String2BigIntFilter.h
	${BACKEND_DIR}/core/datatypes/String2MonthFilter.h
	${BACKEND_DIR}/core/datatypes/String2DateTimeFilter.cpp
	${BACKEND_DIR}/core/datatypes/DateTime2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/DateTime2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/DateTime2BigIntFilter.h
	${BACKEND_DIR}/core/datatypes/DateTime2StringFilter.cpp
	${BACKEND_DIR}/core/datatypes/Month2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/Month2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/Month2BigIntFilter.h
	${BACKEND_DIR}/core/datatypes/DayOfWeek2DoubleFilter.h
	${BACKEND_DIR}/core/datatypes/DayOfWeek2IntegerFilter.h
	${BACKEND_DIR}/core/datatypes/DayOfWeek2BigIntFilter.h
	${BACKEND_DIR}/datasources/filters/AbstractFileFilter.cpp
	${BACKEND_DIR}/datasources/filters/SpiceFilter.cpp
	${BACKEND_DIR}/datasources/filters/SpiceReader.cpp
	${BACKEND_DIR}/datasources/AbstractDataSource.cpp
	${BACKEND_DIR}/datasources/projects/ProjectParser.cpp
	${BACKEND_DIR}/gsl/ExpressionParser.cpp
	${BACKEND_DIR}/gsl/constants.cpp
	${BACKEND_DIR}/gsl/functions.cpp
	${BACKEND_DIR}/lib/Range.h
	${BACKEND_DIR}/lib/Debug.cpp
	${BACKEND_DIR}/lib/XmlStreamReader.cpp
	${BACKEND_DIR}/lib/SignallingUndoCommand.cpp
	${BACKEND_DIR}/lib/hostprocess.cpp
	${BACKEND_DIR}/matrix/Matrix.cpp
	${BACKEND_DIR}/matrix/matrixcommands.cpp
	${BACKEND_DIR}/matrix/MatrixModel.cpp
	${BACKEND_DIR}/note/Note.cpp
	${BACKEND_DIR}/spreadsheet/Spreadsheet.cpp
	${BACKEND_DIR}/spreadsheet/SpreadsheetModel.cpp
	${BACKEND_DIR}/spreadsheet/StatisticsSpreadsheet.cpp
	${BACKEND_DIR}/worksheet/Background.cpp
	${BACKEND_DIR}/worksheet/Image.cpp
	${BACKEND_DIR}/worksheet/Line.cpp
	${BACKEND_DIR}/worksheet/ResizeItem.cpp
	${BACKEND_DIR}/worksheet/WorksheetElement.cpp
	${BACKEND_DIR}/worksheet/TextLabel.cpp
	${BACKEND_DIR}/worksheet/InfoElement.cpp
	${BACKEND_DIR}/worksheet/Worksheet.cpp
	${BACKEND_DIR}/worksheet/WorksheetElementContainer.cpp
	${BACKEND_DIR}/worksheet/WorksheetElementGroup.cpp
	${BACKEND_DIR}/worksheet/TreeModel.cpp
	${BACKEND_DIR}/worksheet/plots/AbstractPlot.cpp
	${BACKEND_DIR}/worksheet/plots/AbstractCoordinateSystem.cpp
	${BACKEND_DIR}/worksheet/plots/PlotArea.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/Axis.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/BarPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/BoxPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/CartesianScale.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/CartesianCoordinateSystem.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/CartesianPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/CartesianPlotLegend.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/ErrorBar.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/Histogram.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/CustomPoint.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/KDEPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/LollipopPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/ReferenceLine.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/Plot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/ReferenceRange.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/Symbol.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/QQPlot.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYAnalysisCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYEquationCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYDataReductionCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYDifferentiationCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYIntegrationCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYInterpolationCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYSmoothCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYFitCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYFourierFilterCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYFourierTransformCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYHilbertTransformCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYConvolutionCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/XYCorrelationCurve.cpp
	${BACKEND_DIR}/worksheet/plots/cartesian/Value.cpp
)

IF (ENABLE_LIBORIGIN)
        list(APPEND BACKEND_SOURCES ${BACKEND_DIR}/datasources/projects/OriginProjectParser.cpp)
ENDIF ()
IF (RECENT_CANTOR)
        list(APPEND BACKEND_SOURCES ${BACKEND_DIR}/cantorWorksheet/CantorWorksheet.cpp ${BACKEND_DIR}/cantorWorksheet/VariableParser.cpp)
ENDIF ()

set(NSL_SOURCES
	${BACKEND_DIR}/nsl/nsl_baseline.cpp
	${BACKEND_DIR}/nsl/nsl_conv.c
	${BACKEND_DIR}/nsl/nsl_corr.c
	${BACKEND_DIR}/nsl/nsl_dft.c
	${BACKEND_DIR}/nsl/nsl_diff.c
	${BACKEND_DIR}/nsl/nsl_filter.c
	${BACKEND_DIR}/nsl/nsl_fit.c
	${BACKEND_DIR}/nsl/nsl_geom.c
	${BACKEND_DIR}/nsl/nsl_geom_linesim.c
	${BACKEND_DIR}/nsl/nsl_hilbert.c
	${BACKEND_DIR}/nsl/nsl_int.c
	${BACKEND_DIR}/nsl/nsl_interp.c
	${BACKEND_DIR}/nsl/nsl_kde.c
	${BACKEND_DIR}/nsl/nsl_math.c
	${BACKEND_DIR}/nsl/nsl_peak.cpp
	${BACKEND_DIR}/nsl/nsl_randist.c
	${BACKEND_DIR}/nsl/nsl_sf_basic.c
	${BACKEND_DIR}/nsl/nsl_sf_kernel.c
	${BACKEND_DIR}/nsl/nsl_sf_poly.c
	${BACKEND_DIR}/nsl/nsl_sf_stats.c
	${BACKEND_DIR}/nsl/nsl_sf_window.c
	${BACKEND_DIR}/nsl/nsl_smooth.c
	${BACKEND_DIR}/nsl/nsl_sort.c
	${BACKEND_DIR}/nsl/nsl_stats.c
)

set(TOOLS_SOURCES
	${TOOLS_DIR}/ImageTools.cpp
	${TOOLS_DIR}/TeXRenderer.cpp
)


IF (NOT MSVC_FOUND)
IF (NOT LIBCERF_FOUND)
	list(APPEND NSL_SOURCES
		${BACKEND_DIR}/nsl/Faddeeva.c
	)
ENDIF ()
ENDIF ()

set(COMMONFRONTEND_SOURCES
	${COMMONFRONTEND_DIR}/matrix/MatrixView.cpp
	${COMMONFRONTEND_DIR}/note/NoteView.cpp
	#	${COMMONFRONTEND_DIR}/spreadsheet/SpreadsheetView.cpp
	${COMMONFRONTEND_DIR}/workbook/WorkbookView.cpp
	${COMMONFRONTEND_DIR}/worksheet/WorksheetView.cpp
)

bison_target(GslParser
	${BACKEND_DIR}/gsl/parser.ypp
	${CMAKE_CURRENT_BINARY_DIR}/gsl_parser.cpp
)
set(GENERATED_SOURCES
	${BISON_GslParser_OUTPUTS}
)

##############################################################################
add_definitions (${QT_DEFINITIONS} ${QT_QTDBUS_DEFINITIONS})
INCLUDE_DIRECTORIES( ../src/ ${BACKEND_DIR}/gsl ${GSL_INCLUDE_DIR} ../src/3rdparty/liborigin ../src/3rdparty/Qt-Advanced-Docking-System/src/ ../src/3rdparty/QXlsx/header/)

# see also QT_MIN_VERSION
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x50500)

# add system QADS include path
#if (qt${QT_VERSION_MAJOR}advanceddocking_FOUND)
#	get_target_property(QADS_INCLUDES ads::qt${QT_VERSION_MAJOR}advanceddocking INTERFACE_INCLUDE_DIRECTORIES)
#	get_target_property(QADS_LIBRARIES ads::qt${QT_VERSION_MAJOR}advanceddocking INTERFACE_LINK_LIBRARIES)
#	MESSAGE (STATUS "QADS Found LINK_LIBRARIES: ${QADS_LIBRARIES} INCLUDES: ${QADS_INCLUDES}")
#	target_include_directories( labplot PRIVATE ${QADS_INCLUDES} )
#endif ()

# dynamic library
add_library(labplot ${GUI_SOURCES} ${BACKEND_SOURCES} ${NSL_SOURCES} ${COMMONFRONTEND_SOURCES} ${TOOLS_SOURCES} ${GENERATED_SOURCES} ${QTMOC_HDRS})
generate_export_header(labplot)

target_link_libraries( labplot
	KF${KF_MAJOR_VERSION}::Archive
	KF${KF_MAJOR_VERSION}::ConfigCore
	KF${KF_MAJOR_VERSION}::ConfigWidgets
	KF${KF_MAJOR_VERSION}::I18n
	KF${KF_MAJOR_VERSION}::KIOCore
	KF${KF_MAJOR_VERSION}::XmlGui
	Qt${QT_MAJOR_VERSION}::Svg
	Qt${QT_MAJOR_VERSION}::Core
	Qt${QT_MAJOR_VERSION}::Gui
	Qt${QT_MAJOR_VERSION}::Widgets
	Qt${QT_MAJOR_VERSION}::PrintSupport
	Qt${QT_MAJOR_VERSION}::Sql
	${GSL_LIBRARIES}
	${GSL_CBLAS_LIBRARIES}
	${FFTW3_LIBRARIES}
	${Poppler_LIBRARIES}
	#	ads::qt${QT_VERSION_MAJOR}advanceddocking
	${LIBCERF_LIBRARIES} )

IF (Discount_FOUND)
	target_link_libraries( labplot Discount::Lib )
ENDIF ()

IF (ENABLE_LIBORIGIN)
	IF (LIBORIGIN_FOUND)
		target_link_libraries( labplot ${LIBORIGIN_LIBRARIES} )
	ELSE ()
		target_link_libraries( labplot liborigin-static )
	ENDIF ()
ENDIF ()

IF (RECENT_CANTOR)
        # KFX::Service, KFX::Parts is optional but probably required by Cantor
        target_link_libraries( labplot Cantor::cantorlibs KF${KF_MAJOR_VERSION}::Service KF${KF_MAJOR_VERSION}::Parts )
ENDIF ()

IF (WIN32)
	target_link_libraries( labplot ${PSAPI} )
ENDIF ()

############## installation ################################
install( TARGETS labplot DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )


install(FILES ${CMAKE_CURRENT_BINARY_DIR}/labplot_export.h  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot COMPONENT Devel)

install( FILES labplot.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/ COMPONENT Devel )
install( FILES ../src/backend/core/AbstractAspect.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/core/ COMPONENT Devel )
install( FILES ../src/backend/core/AbstractColumn.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/core/ COMPONENT Devel )
install( FILES ../src/backend/core/AbstractPart.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/core/ COMPONENT Devel )
install( FILES ../src/backend/core/column/Column.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/core/column/ COMPONENT Devel )
install( FILES ../src/backend/core/column/ColumnPrivate.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/core/column/ COMPONENT Devel )
install( FILES ../src/backend/gsl/parser.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/gsl/ COMPONENT Devel )
install( FILES ../src/backend/lib/Interval.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/lib/ COMPONENT Devel )
install( FILES ../src/backend/lib/IntervalAttribute.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/lib/ COMPONENT Devel )
install( FILES ../src/backend/lib/macros.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/backend/lib/ COMPONENT Devel )

=== src/CMakeLists.txt ===

find_package(SharedMimeInfo REQUIRED)
set(KDE_FRONTEND true)
set(KDEFRONTEND_DIR kdefrontend)
set(BACKEND_DIR backend)
set(COMMONFRONTEND_DIR commonfrontend)
set(CANTOR_DIR cantor)
set(TOOLS_DIR tools)
set(CMAKE_AUTOMOC ON)
set(SRC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)

find_package(qt${QT_VERSION_MAJOR}advanceddocking CONFIG)
if (NOT qt${QT_VERSION_MAJOR}advanceddocking_FOUND)
	option(LOCAL_QT_ADVANCED_DOCK_DOWNLOAD "Use local build of qt advanced dock downloaded directly from the git repository" OFF)
	option(LOCAL_QT_ADVANCED_DOCK_COPY "Use local build of qt advanced dock copied into the Qt-Advanced-Docking-System subfolder" ON)
	if (TARGET Qt${QT_VERSION_MAJOR}::GuiPrivate)
		MESSAGE (STATUS "Building local version of Qt-Advanced-Docking-System.")
	else ()
		MESSAGE (FATAL_ERROR "Missing Qt${QT_VERSION_MAJOR}::GuiPrivate to build local version of Qt-Advanced-Docking-System.")
	endif ()
endif ()

set(GUI_SOURCES
	${KDEFRONTEND_DIR}/DatasetModel.cpp
	${KDEFRONTEND_DIR}/GuiObserver.cpp
	${KDEFRONTEND_DIR}/PlotTemplateDialog.cpp
	${KDEFRONTEND_DIR}/GuiTools.cpp
	${KDEFRONTEND_DIR}/HistoryDialog.cpp
	${KDEFRONTEND_DIR}/MainWin.cpp
	${KDEFRONTEND_DIR}/SettingsDialog.cpp
	${KDEFRONTEND_DIR}/SettingsGeneralPage.cpp
	${KDEFRONTEND_DIR}/SettingsNotebookPage.cpp
	${KDEFRONTEND_DIR}/SettingsSpreadsheetPage.cpp
	${KDEFRONTEND_DIR}/SettingsWorksheetPage.cpp
# 	${KDEFRONTEND_DIR}/SettingsWelcomePage.cpp
	${KDEFRONTEND_DIR}/SettingsDatasetsPage.cpp
	${KDEFRONTEND_DIR}/SettingsPage.h
	${KDEFRONTEND_DIR}/CASSettingsDialog.cpp
	${KDEFRONTEND_DIR}/TemplateHandler.cpp
	${KDEFRONTEND_DIR}/ThemeHandler.cpp
	${KDEFRONTEND_DIR}/examples/ExamplesDialog.cpp
	${KDEFRONTEND_DIR}/examples/ExamplesManager.cpp
	${KDEFRONTEND_DIR}/examples/ExamplesWidget.cpp
# 	${KDEFRONTEND_DIR}/welcomescreen/WelcomeScreenHelper.cpp
	${KDEFRONTEND_DIR}/colormaps/ColorMapsWidget.cpp
	${KDEFRONTEND_DIR}/colormaps/ColorMapsDialog.cpp
	${KDEFRONTEND_DIR}/datasources/AsciiOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/CANOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/BinaryOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/DatabaseManagerDialog.cpp
	${KDEFRONTEND_DIR}/datasources/DatabaseManagerWidget.cpp
	${KDEFRONTEND_DIR}/datasources/DatasetMetadataManagerDialog.cpp
	${KDEFRONTEND_DIR}/datasources/DatasetMetadataManagerWidget.cpp
	${KDEFRONTEND_DIR}/datasources/OdsOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/XLSXOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/HDF5OptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/ImageOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/ImportDatasetWidget.cpp
	${KDEFRONTEND_DIR}/datasources/ImportDatasetDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportWarningsDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportFileWidget.cpp
	${KDEFRONTEND_DIR}/datasources/ImportFileDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportProjectDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportSQLDatabaseDialog.cpp
	${KDEFRONTEND_DIR}/datasources/ImportSQLDatabaseWidget.cpp
	${KDEFRONTEND_DIR}/datasources/MatioOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/NetCDFOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/ROOTOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/FITSOptionsWidget.cpp
	${KDEFRONTEND_DIR}/datasources/JsonOptionsWidget.cpp
	${KDEFRONTEND_DIR}/dockwidgets/BaseDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/AspectDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/AxisDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/CursorDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/ImageDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/InfoElementDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/NoteDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/CartesianPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/CartesianPlotLegendDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/HistogramDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/BarPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/BoxPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/CustomPointDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/ColumnDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/KDEPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/LiveDataDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/LollipopPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/MatrixDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/ProjectDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/ReferenceLineDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/ReferenceRangeDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/SpreadsheetDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/StatisticsSpreadsheetDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/QQPlotDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYAnalysisCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYEquationCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYDataReductionCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYDifferentiationCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYIntegrationCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYInterpolationCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYSmoothCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYFitCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYFourierFilterCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYFourierTransformCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYHilbertTransformCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYConvolutionCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/XYCorrelationCurveDock.cpp
	${KDEFRONTEND_DIR}/dockwidgets/WorksheetDock.cpp
	${KDEFRONTEND_DIR}/matrix/MatrixFunctionDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/PlotDataDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/EquidistantValuesDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/ExportSpreadsheetDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/AddSubtractValueDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/AddValueLabelDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/BatchEditValueLabelsDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/DropValuesDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/FlattenColumnsDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/FormattingHeatmapDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/GoToDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/FunctionValuesDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/RandomValuesDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/RescaleDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/SampleValuesDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/SearchReplaceWidget.cpp
	${KDEFRONTEND_DIR}/spreadsheet/SortDialog.cpp
	${KDEFRONTEND_DIR}/spreadsheet/StatisticsColumnWidget.cpp
	${KDEFRONTEND_DIR}/spreadsheet/StatisticsDialog.cpp
	${KDEFRONTEND_DIR}/worksheet/ExportWorksheetDialog.cpp
	${KDEFRONTEND_DIR}/worksheet/GridDialog.cpp
	${KDEFRONTEND_DIR}/worksheet/PresenterWidget.cpp
	${KDEFRONTEND_DIR}/worksheet/SlidingPanel.cpp
	${KDEFRONTEND_DIR}/worksheet/WorksheetPreviewWidget.cpp
	${KDEFRONTEND_DIR}/widgets/BackgroundWidget.cpp
	${KDEFRONTEND_DIR}/widgets/ConstantsWidget.cpp
	${KDEFRONTEND_DIR}/widgets/ThemesComboBox.cpp
	${KDEFRONTEND_DIR}/widgets/ThemesWidget.cpp
	${KDEFRONTEND_DIR}/widgets/ExpressionTextEdit.cpp
	${KDEFRONTEND_DIR}/widgets/FitOptionsWidget.cpp
	${KDEFRONTEND_DIR}/widgets/FitParametersWidget.cpp
	${KDEFRONTEND_DIR}/widgets/FunctionsWidget.cpp
	${KDEFRONTEND_DIR}/widgets/LabelWidget.cpp
	${KDEFRONTEND_DIR}/widgets/ErrorBarWidget.cpp
	${KDEFRONTEND_DIR}/widgets/LineWidget.cpp
	${KDEFRONTEND_DIR}/widgets/SymbolWidget.cpp
	${KDEFRONTEND_DIR}/widgets/ValueWidget.cpp
	${KDEFRONTEND_DIR}/widgets/DatapickerImageWidget.cpp
	${KDEFRONTEND_DIR}/widgets/DatapickerCurveWidget.cpp
	${KDEFRONTEND_DIR}/widgets/FITSHeaderEditWidget.cpp
	${KDEFRONTEND_DIR}/widgets/FITSHeaderEditNewKeywordDialog.cpp
	${KDEFRONTEND_DIR}/widgets/FITSHeaderEditAddUnitDialog.cpp
	${KDEFRONTEND_DIR}/widgets/FITSHeaderEditDialog.cpp
	${KDEFRONTEND_DIR}/widgets/ResizableTextEdit.cpp
	${KDEFRONTEND_DIR}/widgets/TimedLineEdit.cpp
)

if (Qt${QT_VERSION_MAJOR}Mqtt_FOUND)
	list(APPEND GUI_SOURCES ${KDEFRONTEND_DIR}/datasources/MQTTConnectionManagerWidget.cpp)
	list(APPEND GUI_SOURCES ${KDEFRONTEND_DIR}/datasources/MQTTConnectionManagerDialog.cpp)
	list(APPEND GUI_SOURCES ${KDEFRONTEND_DIR}/datasources/MQTTErrorWidget.cpp)
	list(APPEND GUI_SOURCES ${KDEFRONTEND_DIR}/datasources/MQTTSubscriptionWidget.cpp)
endif()

if (APPLE)
  list(APPEND GUI_SOURCES ${KDEFRONTEND_DIR}/worksheet/PresenterWidget_mac.mm)
endif()

set(GUI_QRC
	${KDEFRONTEND_DIR}/labplot2.qrc
)

set(UI_SOURCES
	${KDEFRONTEND_DIR}/ui/colormapswidget.ui
	${KDEFRONTEND_DIR}/ui/constantswidget.ui
	${KDEFRONTEND_DIR}/ui/PlotTemplateDialog.ui
	${KDEFRONTEND_DIR}/ui/exampleswidget.ui
	${KDEFRONTEND_DIR}/ui/functionswidget.ui
	${KDEFRONTEND_DIR}/ui/fitoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/fitparameterswidget.ui
	${KDEFRONTEND_DIR}/ui/labelwidget.ui
	${KDEFRONTEND_DIR}/ui/symbolwidget.ui
	${KDEFRONTEND_DIR}/ui/settingsnotebookpage.ui
	${KDEFRONTEND_DIR}/ui/settingsgeneralpage.ui
	${KDEFRONTEND_DIR}/ui/settingsspreadsheetpage.ui
	${KDEFRONTEND_DIR}/ui/settingsworksheetpage.ui
# 	${KDEFRONTEND_DIR}/ui/settingswelcomepage.ui
	${KDEFRONTEND_DIR}/ui/settingsdatasetspage.ui
	${KDEFRONTEND_DIR}/ui/settingsprintingpage.ui
	${KDEFRONTEND_DIR}/ui/datasources/asciioptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/CANOptionsWidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/binaryoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/databasemanagerwidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/datasetmetadatamanagerwidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/hdf5optionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/imageoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/importdatasetwidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/importfilewidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/importwarningsdialog.ui
	${KDEFRONTEND_DIR}/ui/datasources/importprojectwidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/importsqldatabasewidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/matiooptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/netcdfoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/rootoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/fitsoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/jsonoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/odsoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/datasources/xlsxoptionswidget.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/aspectdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/axisdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/backgroundwidget.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/cursordock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/infoelementdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/cartesianplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/cartesianplotlegenddock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/histogramdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/barplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/boxplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/columndock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/custompointdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/errorbarwidget.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/imagedock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/kdeplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/linewidget.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/livedatadock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/lollipopplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/notedock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/matrixdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/projectdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/referencelinedock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/referencerangedock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/spreadsheetdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/statisticsspreadsheetdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/qqplotdock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xycurvedock.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xycurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xydatareductioncurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xydifferentiationcurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xyintegrationcurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xyinterpolationcurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xysmoothcurvedockgeneraltab.ui
	${KDEFRONTEND_DIR}/ui/dockwidgets/xyfitcurvedockgeneraltab.ui

=== data/example_projects/CMakeLists.txt ===
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)

=== data/themes/CMakeLists.txt ===
if (APPLE)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR} PATTERN "CMakeLists.txt" EXCLUDE)
else ()
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)
endif ()

=== lib/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(QT_MAJOR_VERSION "5")
set(KF_MAJOR_VERSION "5")
set(QT_MIN_VERSION "5.10.0")
set(KF_MIN_VERSION "5.16.0")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH})

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} COMPONENTS Widgets REQUIRED)
find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
	Config
	I18n
)

add_executable(example main.cpp)
INCLUDE_DIRECTORIES(/usr/include/labplot/)

target_link_libraries(example labplot Qt${QT_MAJOR_VERSION}::Widgets KF${KF_MAJOR_VERSION}::ConfigCore KF${KF_MAJOR_VERSION}::I18n)

=== src/3rdparty/CMakeLists.txt ===
IF (APPLE AND ENABLE_TOUCHBAR)
	add_subdirectory(kdmactouchbar)
ENDIF ()

IF (ENABLE_LIBORIGIN AND NOT LIBORIGIN_FOUND)
	add_subdirectory(liborigin)
ENDIF ()

IF (BUILD_READSTAT)
	include(ExternalProject)

	set(build_dir ${CMAKE_BINARY_DIR}/src/3rdparty)
	set(install_dir ${build_dir}/install)
	file(MAKE_DIRECTORY ${install_dir}/lib)
	file(MAKE_DIRECTORY ${install_dir}/include)

	set(ext_src ${build_dir}/readstat/src/readstat)
	# TODO: find easy (and portable) way to get latest version
	# curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest | grep 'browser_download_url.*.tar.gz' | cut -d\" -f4
	# curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest | jq --raw-output '.assets[0] | .browser_download_url'
	# execute_process(COMMAND "curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest |   jq --raw-output '.assets[0] | .browser_download_url'" OUTPUT_VARIABLE ext_url)
	set(ext_version "1.1.9")
	set(ext_url https://github.com/WizardMac/ReadStat/releases/download/v${ext_version}/readstat-${ext_version}.tar.gz)
#if(WIN32)	# not used (own version on Windows)
#        set(ext_url http://sourceforge.net/projects/kst/files/3rdparty/zlib-develop-mingw-fixed.zip)
#        set(ext_configure cmake ${ext_src} ${generator} -DBUILD_SHARED_LIBS=0 ${rc_compiler} ${install_prefix} ${build_type})
#        set(ext_install ${install_target})
#        set(ext_insource OFF )
#                set(zlib_library libzlibstatic.a)
#        set(ext_make ${kst_make_program})
#else()

	# --prefix=${install_dir} does not work with spaces
        set(ext_configure ${ext_src}/configure --enable-static --disable-shared)
	set(ext_insource ON)
	#set(ext_make ${CMAKE_MAKE_PROGRAM} CXXFLAGS=-fPIC CFLAGS=-fPIC)

	set(patch_command git apply ${CMAKE_CURRENT_SOURCE_DIR}/patches/readstat-1.1.9.patch)
	set(readstat_library libreadstat.a)
#endif()
	ExternalProject_Add(3rdparty_readstat
		PREFIX ${build_dir}/readstat
		URL ${ext_url}
		SOURCE_DIR ${ext_src}
		CONFIGURE_COMMAND ${ext_configure}
		BUILD_IN_SOURCE ${ext_insource}
		PATCH_COMMAND ${patch_command}
		#BUILD_COMMAND ${ext_make}
		# libtool install does not work with spaces
		#INSTALL_COMMAND ${CMAKE_MAKE_PROGRAM} install
		INSTALL_COMMAND cp -av .libs/${readstat_library} ${install_dir}/lib/ && cp -av src/readstat.h ${install_dir}/include/
		BUILD_BYPRODUCTS ${install_dir}/lib/${readstat_library}
	)
ENDIF ()

IF (BUILD_QXLSX)
	set(BUILD_SHARED_LIBS OFF)
	add_subdirectory(QXlsx EXCLUDE_FROM_ALL)
ENDIF ()

# preview.sty
install(FILES preview.sty DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME}/latex)

Include(FetchContent)

### Vector BLF ###############################
FIND_PACKAGE(PkgConfig REQUIRED)
# git download is not allowed on all system (set to ON if needed)
option(LOCAL_DBC_PARSER "Use local build of dbc parser" OFF)
option(LOCAL_VECTOR_BLF "Use local build of Vector BLF" OFF)
if (ENABLE_VECTOR_BLF)
  set(OPTION_RUN_DOXYGEN OFF CACHE BOOL "" FORCE) # disable running doxygen
  if (${LOCAL_DBC_PARSER})
      FetchContent_Declare(
        dbc_parser_cpp
        GIT_REPOSITORY https://github.com/LinuxDevon/dbc_parser_cpp.git
        GIT_TAG cc4e80c7b6e1f7a13cc47b45f226756f823888e2 # v0.4.0
      )
      # fix missing variable and keyword for fast_float
      IF (NOT MSVC_FOUND)
          add_definitions (-DFASTFLOAT_VISUAL_STUDIO=0)
          add_definitions (-D__forceinline=inline)
      ENDIF ()
      # disable -Werror=maybe-uninitialized since gcc gives false positive warnings when address sanitizer is used
      IF ("${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
          set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized")
      ENDIF ()
      # dbc is the root project name
      # https://gitlab.kitware.com/cmake/cmake/-/issues/19854
      set(CMAKE_PROJECT_dbc_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/dbc_database_parser_disableTests.cmake")
      # don't install dbc_parser_cpp
      # see https://stackoverflow.com/questions/65527126/disable-install-for-fetchcontent
      # FetchContent_MakeAvailable(dbc_parser_cpp)
      FetchContent_GetProperties(dbc_parser_cpp)
      if(NOT dbc_parser_cpp_POPULATED)
          FetchContent_Populate(dbc_parser_cpp)
          add_subdirectory(${dbc_parser_cpp_SOURCE_DIR} ${dbc_parser_cpp_BINARY_DIR} EXCLUDE_FROM_ALL)
      endif()
      # headerfiles of the projects are referring to <libdbc/someheader.h> and therefore
      # the path must be added
      target_include_directories(labplot2backendlib PUBLIC ${dbc_parser_cpp_SOURCE_DIR}/include)
      target_link_libraries(labplot2backendlib dbc)
      target_compile_definitions(labplot2backendlib PRIVATE HAVE_DBC_PARSER)
      target_compile_definitions(labplot2lib PUBLIC HAVE_DBC_PARSER)
  else ()
    pkg_check_modules(dbc IMPORTED_TARGET GLOBAL dbc)
    if (dbc_FOUND)
        target_link_libraries(labplot2backendlib PkgConfig::dbc)
        target_compile_definitions(labplot2backendlib PRIVATE HAVE_DBC_PARSER)
        target_compile_definitions(labplot2lib PUBLIC HAVE_DBC_PARSER)
    endif()
  endif()
  
  if (${LOCAL_VECTOR_BLF})
    FetchContent_Declare(
        vector_blf
        #GIT_REPOSITORY https://github.com/Technica-Engineering/vector_blf.git
        #GIT_TAG 02f0a2fe1f7915da1e24025869b98f6d15de937b
        GIT_REPOSITORY https://github.com/Murmele/vector_blf.git
        GIT_TAG 2c1a8e649328f2e06ce4d45c6223628bc39fd178
      )
      set(CMAKE_PROJECT_Vector_BLF_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/vector_blf_config.cmake")
      # TODO: link static and don't install (see dbc_parser_cpp)
      FetchContent_MakeAvailable(vector_blf)
      # headerfiles of the projects are referring to <Vector/BLF/someheader.h> and therefore
      # the path must be added
      set(CMAKE_SYSTEM_INCLUDE_PATH ${CMAKE_SYSTEM_INCLUDE_PATH}
          ${vector_blf_SOURCE_DIR}/src
          ${vector_blf_BINARY_DIR}/src) # config.h is in there
      target_include_directories(Vector_BLF PUBLIC ${vector_blf_SOURCE_DIR}/src
                          ${vector_blf_BINARY_DIR}/src) # config.h is in there
      target_link_libraries(labplot2backendlib Vector_BLF)
      target_compile_definitions(labplot2backendlib PRIVATE HAVE_VECTOR_BLF)
      target_compile_definitions(labplot2lib PUBLIC HAVE_VECTOR_BLF)
      add_definitions (-DHAVE_VECTOR_BLF)
  else()
    pkg_check_modules(Vector_BLF IMPORTED_TARGET GLOBAL Vector_BLF)
    if (Vector_BLF_FOUND)
        target_link_libraries(labplot2backendlib PkgConfig::Vector_BLF)
        target_compile_definitions(labplot2backendlib PRIVATE HAVE_VECTOR_BLF)
        target_compile_definitions(labplot2lib PUBLIC HAVE_VECTOR_BLF)
        add_definitions (-DHAVE_VECTOR_BLF)
    endif()
  endif()
else()
    add_definitions (-DVECTOR_BLF_DISABLED)
endif()

if (LOCAL_QT_ADVANCED_DOCK_DOWNLOAD)
    FetchContent_Declare(
        qt_advanced_dock
        GIT_REPOSITORY https://github.com/githubuser0xFFFF/Qt-Advanced-Docking-System.git
        GIT_TAG a940fc29c6d1fbcb5ee1e2fecf86f20bb86a7fb6
    )
    set(CMAKE_PROJECT_QtADS_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtADS_config.cmake")
    # don't install qt_advanced_dock
    # see https://stackoverflow.com/questions/65527126/disable-install-for-fetchcontent
    # FetchContent_MakeAvailable(qt_advanced_dock)
    FetchContent_GetProperties(qt_advanced_dock)
    if(NOT qt_advanced_dock_POPULATED)
        FetchContent_Populate(qt_advanced_dock)
        add_subdirectory(${qt_advanced_dock_SOURCE_DIR} ${qt_advanced_dock_BINARY_DIR} EXCLUDE_FROM_ALL)
    endif()
elseif(LOCAL_QT_ADVANCED_DOCK_COPY)
    # https://cmake.org/cmake/help/latest/variable/CMAKE_PROJECT_INCLUDE.html
    set(CMAKE_PROJECT_QtADS_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtADS_config.cmake")
    set(ADS_VERSION ${labplot2_VERSION})
    add_subdirectory(Qt-Advanced-Docking-System EXCLUDE_FROM_ALL)
endif()

=== tests/backend/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND "Enable Backend Tests" ON)

if (ENABLE_TEST_BACKEND)

    add_subdirectory(Axis)
    add_subdirectory(BarPlot)
    add_subdirectory(Column)
    add_subdirectory(core)
    add_subdirectory(Datapicker)
    add_subdirectory(gsl)
    add_subdirectory(InfoElement)
    add_subdirectory(Parser)
    add_subdirectory(Range)
    add_subdirectory(Retransform)
    add_subdirectory(TextLabel)
    add_subdirectory(Worksheet)
    add_subdirectory(XYCurve)

endif()

=== tests/cartesianplot/CMakeLists.txt ===
option(ENABLE_TEST_CARTESIANPLOT "Enable CartesianPlot Tests" ON)

if (ENABLE_TEST_CARTESIANPLOT)

    add_executable (CartesianPlotTest CartesianPlotTest.cpp)
    target_link_libraries(CartesianPlotTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
    add_test(NAME CartesianPlotTest COMMAND CartesianPlotTest)

    add_subdirectory(plots)

endif()

=== tests/commonfrontend/CMakeLists.txt ===
option(ENABLE_TEST_COMMONFRONTEND "Enable Common frontend Tests" ON)

if (ENABLE_TEST_COMMONFRONTEND)

    add_subdirectory(widgets)

endif()

=== tests/import_export/CMakeLists.txt ===
option(ENABLE_TEST_IMPORTEXPORT "Enable Import/Export Tests" ON)

if (ENABLE_TEST_IMPORTEXPORT)

    add_subdirectory(ASCII)
    add_subdirectory(Binary)
    add_subdirectory(JSON)
    add_subdirectory(MQTT)
    add_subdirectory(Project)
    add_subdirectory(Spice)
    add_subdirectory(CAN)
    add_subdirectory(SQL)

    option(ENABLE_TEST_IMPORTEXPORT_ROOT "Enable Root Tests" ON)
    IF (ZLIB_FOUND AND LZ4_FOUND AND ENABLE_TEST_IMPORTEXPORT_ROOT)
            add_subdirectory(ROOT)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_READSTAT "Enable Readstat Tests" ON)
    IF ((READSTAT_FOUND OR BUILD_READSTAT) AND ENABLE_TEST_IMPORTEXPORT_READSTAT)
            add_subdirectory(ReadStat)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_MATIO "Enable Matio Tests" ON)
    IF (MATIO_FOUND AND ENABLE_TEST_IMPORTEXPORT_MATIO)
            add_subdirectory(Matio)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_HDF5 "Enable HDF5 Tests" ON)
    IF (HDF5_FOUND AND ENABLE_TEST_IMPORTEXPORT_HDF5)
            add_subdirectory(HDF5)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_CFITSIO "Enable CFitsio Tests" ON)
    IF (CFITSIO_FOUND AND ENABLE_TEST_IMPORTEXPORT_CFITSIO)
            add_subdirectory(FITS)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_NETCDF "Enable Netcdf Tests" ON)
    IF (NETCDF_FOUND AND ENABLE_TEST_IMPORTEXPORT_NETCDF)
            add_subdirectory(NetCDF)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_EXCEL "Enable Excel Tests" ON)
    IF ((QXLSX_FOUND OR BUILD_EXCEL) AND ENABLE_TEST_IMPORTEXPORT_EXCEL)
            add_subdirectory(XLSX)
    ENDIF ()

    option(ENABLE_TEST_IMPORTEXPORT_ORCUS "Enable Orcus Tests" ON)
    IF (ORCUS_FOUND AND ENABLE_TEST_IMPORTEXPORT_ORCUS)
            add_subdirectory(Ods)
    ENDIF ()

    add_subdirectory(Datasets)

endif()

=== debian/changelog ===
labplot (2.11.1-2) unstable; urgency=medium

  * Disable the Cantor integration for now, as Cantor will be switched soon to
    Qt 6:
    - drop the libcantor-dev build dependency

 -- Pino Toscano <pino@debian.org>  Tue, 18 Feb 2025 22:52:03 +0100

labplot (2.11.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - add liborcus-dev, and libixion-dev
    - add libboost-dev as missing dependency of libixion-dev

 -- Pino Toscano <pino@debian.org>  Wed, 17 Jul 2024 21:05:08 +0200

labplot (2.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.12.0
    - bump KF packages to 5.32.0
    - add qtbase5-private-dev, libkf5purpose-dev, and libeigen3-dev
    - add libqt5sql5-sqlite for tests
  * Update the patches:
    - upstream_matio-Fix-compilation-for-latest-version-1.5.27.patch: drop,
      backported from upstream
  * Do not ship development bits (e.g. headers) for now.
  * Update install files.
  * Update lintian overrides.
  * CI: make the build non-verbose, so the build log fits within the salsa
    limits.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Jul 2024 21:07:39 +0200

labplot (2.10.1-3) unstable; urgency=medium

  * Backport upstream commit d6142308ffa492d9f7cea00fad3b4cd1babfd00c to fix the
    build with newer versions of matio; patch
    upstream_matio-Fix-compilation-for-latest-version-1.5.27.patch.
    (Closes: #1072280)
  * Bump Standards-Version to 4.7.0, no changes required.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sun, 02 Jun 2024 21:04:24 +0200

=== debian/control ===
Source: labplot
Section: math
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.17.0~),
 gettext,
 pkg-kde-tools (>= 0.15.16),
 pkgconf,
 qtbase5-dev (>= 5.12.0~),
 qtbase5-private-dev (>= 5.12.0~),
 libqt5svg5-dev (>= 5.12.0~),
 libqt5serialport5-dev (>= 5.12.0~),
 extra-cmake-modules (>= 5.32.0~),
 libkf5archive-dev (>= 5.32.0~),
 libkf5completion-dev (>= 5.32.0~),
 libkf5config-dev (>= 5.32.0~),
 libkf5configwidgets-dev (>= 5.32.0~),
 libkf5coreaddons-dev (>= 5.32.0~),
 libkf5crash-dev (>= 5.32.0~),
 libkf5doctools-dev (>= 5.32.0~),
 libkf5i18n-dev (>= 5.32.0~),
 libkf5iconthemes-dev (>= 5.32.0~),
 libkf5kio-dev (>= 5.32.0~),
 libkf5newstuff-dev (>= 5.32.0~),
 libkf5parts-dev (>= 5.32.0~),
 libkf5purpose-dev (>= 5.32.0~),
 libkf5service-dev (>= 5.32.0~),
 libkf5syntaxhighlighting-dev (>= 5.32.0~),
 libkf5textwidgets-dev (>= 5.32.0~),
 libkf5widgetsaddons-dev (>= 5.32.0~),
 libkf5xmlgui-dev (>= 5.32.0~),
 kuserfeedback-dev,
 bison,
 libpoppler-qt5-dev (>= 19.12~),
 libspectre-dev,
 libcfitsio-dev,
 libgsl-dev,
 libnetcdf-dev,
 libfftw3-dev,
 libhdf5-dev,
 libcerf-dev,
 zlib1g-dev,
 liblz4-dev,
 libmarkdown2-dev,
 libmatio-dev,
 libreadstat-dev,
 libqt5qxlsx-dev,
 libeigen3-dev,
 liborcus-dev,
 libixion-dev,
# missing dependency in libixion
 libboost-dev,
 xauth <!nocheck>,
 xvfb <!nocheck>,
 locales-all <!nocheck>,
 libqt5sql5-sqlite <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/labplot
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/labplot.git
Homepage: https://labplot.kde.org/

Package: labplot
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 labplot-data (= ${source:Version}),
Description: interactive graphing and analysis of scientific data
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 Features include:
  - project-based management of data
  - project explorer for management and organization of created objects in
    different folders and sub-folders
  - spreadsheet with basic functionality for manual data entry or for
    generation of uniform and non-uniform random numbers
  - import of external ASCII data into the project for further editing and
    visualization
  - export of spreadsheet to an ASCII file
  - worksheet as the main parent object for plots, labels, etc; supports
    different layouts and zooming functions
  - export of worksheet to different formats (PDF, EPS, PNG, and SVG)
  - great variety of editing capabilities for properties of worksheet and its
    objects
  - cartesian plots, created either from imported or manually created data
    sets or via mathematical equation
  - definition of mathematical formulas is supported by syntax highlighting
    and completion and by the list of thematically grouped mathematical and
    physical constants and functions
  - analysis of plotted data is supported by many zooming and navigation
    features
  - linear and non-linear fits to data, several fit-models are predefined and
    custom models with arbitrary number of parameters can be provided

Package: labplot-data
Architecture: all
Depends: ${misc:Depends}
Description: data files for labplot
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 This contains the data files for labplot.

=== debian/rules ===
#!/usr/bin/make -f

# Disable fixfilepath, as it causes build failures.
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DENABLE_REPRODUCIBLE=ON -DENABLE_VECTOR_BLF=OFF

override_dh_auto_test:
	# non-fatal, as tests fail on almost non-amd64 archs
	-xvfb-run dh_auto_test

execute_after_dh_auto_install:
	# remove symlinks of private libraries
	find debian/tmp -name '*.so' -type l -print -delete
	# remove development headers
	rm -rfv debian/tmp/usr/include/
